﻿//
// ConsoleCSharp
//
// Copyright (c) 2016 http://www.curict.com
// This software is released under the MIT License, see LICENSE.txt.
//

using System;

namespace ConsoleCSharp
{
    class Program
    {
        static void Main(string[] args)
        {
            // 丸め
            Round();

            // 切り捨て
            TruncateFloor();

            // 切り上げ
            Ceiling();

            Console.ReadLine();
        }

        /// <summary>
        /// 丸め
        /// </summary>
        static void Round()
        {
            // 最近接偶数への丸め(銀行家の丸め・JIS丸め) 
            Console.WriteLine("最近接偶数への丸め(銀行家の丸め・JIS丸め)  ");
            double result01 = Math.Round(0.5); // 0
            double result02 = Math.Round(1.5); // 2
            double result03 = Math.Round(2.5); // 2
            double result04 = Math.Round(3.5); // 4
            Console.WriteLine("Math.Round(0.5, 1)) = " + result01);
            Console.WriteLine("Math.Round(1.5, 1)) = " + result02);
            Console.WriteLine("Math.Round(2.5, 1)) = " + result03);
            Console.WriteLine("Math.Round(3.5, 1)) = " + result04);

            // 小数部の桁数を指定した最近接偶数への丸め(銀行家の丸め・JIS丸め) 
            Console.WriteLine("小数部の桁数を指定した最近接偶数への丸め(銀行家の丸め・JIS丸め) ");
            double result11 = Math.Round(0.05, 1); // 0
            double result12 = Math.Round(0.15, 1); // 0.2
            double result13 = Math.Round(0.25, 1); // 0.2
            double result14 = Math.Round(0.35, 1); // 0.4
            Console.WriteLine("Math.Round(0.05, 1)) = " + result11);
            Console.WriteLine("Math.Round(0.15, 1)) = " + result12);
            Console.WriteLine("Math.Round(0.25, 1)) = " + result13);
            Console.WriteLine("Math.Round(0.35, 1)) = " + result14);

            // 四捨五入
            Console.WriteLine("四捨五入");
            double result21 = Math.Round(0.5, MidpointRounding.AwayFromZero); // 1
            double result22 = Math.Round(1.5, MidpointRounding.AwayFromZero); // 2
            double result23 = Math.Round(2.5, MidpointRounding.AwayFromZero); // 3
            double result24 = Math.Round(3.5, MidpointRounding.AwayFromZero); // 4
            Console.WriteLine("Math.Round(0.5, MidpointRounding.AwayFromZero)) = " + result21);
            Console.WriteLine("Math.Round(1.5, MidpointRounding.AwayFromZero)) = " + result22);
            Console.WriteLine("Math.Round(2.5, MidpointRounding.AwayFromZero)) = " + result23);
            Console.WriteLine("Math.Round(3.5, MidpointRounding.AwayFromZero)) = " + result24);

            // 小数部の桁数を指定した四捨五入
            Console.WriteLine("小数部の桁数を指定した四捨五入");
            double result31 = Math.Round(0.05, 1, MidpointRounding.AwayFromZero); // 0.1
            double result32 = Math.Round(0.15, 1, MidpointRounding.AwayFromZero); // 0.2
            double result33 = Math.Round(0.25, 1, MidpointRounding.AwayFromZero); // 0.3
            double result34 = Math.Round(0.35, 1, MidpointRounding.AwayFromZero); // 0.4
            Console.WriteLine("Math.Round(0.05, , MidpointRounding.AwayFromZero1)) = " + result31);
            Console.WriteLine("Math.Round(0.15, 1, MidpointRounding.AwayFromZero)) = " + result32);
            Console.WriteLine("Math.Round(0.25, 1, MidpointRounding.AwayFromZero)) = " + result33);
            Console.WriteLine("Math.Round(0.35, 1, MidpointRounding.AwayFromZero)) = " + result34);
        }

        /// <summary>
        /// 切り捨て
        /// </summary>
        static void TruncateFloor()
        {
            // 切り捨て(Math.Truncate) 
            Console.WriteLine("切り捨て(Math.Truncate) ");
            double result01 = Math.Truncate(0.1); // 0
            double result02 = Math.Truncate(0.9); // 0
            double result03 = Math.Truncate(1.1); // 1
            double result04 = Math.Truncate(1.9); // 1
            double result11 = Math.Truncate(-0.1); // 0
            double result12 = Math.Truncate(-0.9); // 0
            double result13 = Math.Truncate(-1.1); // -1
            double result14 = Math.Truncate(-1.9); // -1
            Console.WriteLine("Math.Truncate(0.1)) = " + result01);
            Console.WriteLine("Math.Truncate(0.9)) = " + result02);
            Console.WriteLine("Math.Truncate(1.1)) = " + result03);
            Console.WriteLine("Math.Truncate(1.9)) = " + result04);
            Console.WriteLine("Math.Truncate(-0.1)) = " + result11);
            Console.WriteLine("Math.Truncate(-0.9)) = " + result12);
            Console.WriteLine("Math.Truncate(-1.1)) = " + result13);
            Console.WriteLine("Math.Truncate(-1.9)) = " + result14);

            // 小数部の桁数を指定した切り捨て(Math.Truncate) 
            Console.WriteLine("小数部の桁数を指定した切り捨て(Math.Truncate) ");
            double result21 = Math.Truncate(0.1234 * Math.Pow(10, 1)) / Math.Pow(10, 1); // 0.1
            double result22 = Math.Truncate(0.1234 * Math.Pow(10, 2)) / Math.Pow(10, 2); // 0.12
            double result23 = Math.Truncate(0.1234 * Math.Pow(10, 3)) / Math.Pow(10, 3); // 0.123
            double result31 = Math.Truncate(-0.1234 * Math.Pow(10, 1)) / Math.Pow(10, 1); // -0.1
            double result32 = Math.Truncate(-0.1234 * Math.Pow(10, 2)) / Math.Pow(10, 2); // -0.12
            double result33 = Math.Truncate(-0.1234 * Math.Pow(10, 3)) / Math.Pow(10, 3); // -0.123
            Console.WriteLine("Math.Truncate(0.1234 * Math.Pow(10, 1)) / Math.Pow(10, 1) = " + result21);
            Console.WriteLine("Math.Truncate(0.1234 * Math.Pow(10, 2)) / Math.Pow(10, 2) = " + result22);
            Console.WriteLine("Math.Truncate(0.1234 * Math.Pow(10, 3)) / Math.Pow(10, 3) = " + result23);
            Console.WriteLine("Math.Truncate(-0.1234 * Math.Pow(10, 1)) / Math.Pow(10, 1) = " + result31);
            Console.WriteLine("Math.Truncate(-0.1234 * Math.Pow(10, 2)) / Math.Pow(10, 2) = " + result32);
            Console.WriteLine("Math.Truncate(-0.1234 * Math.Pow(10, 3)) / Math.Pow(10, 3) = " + result33);

            // 切り捨て(Math.Floor) 
            Console.WriteLine("切り捨て(Math.Floor) ");
            double result41 = Math.Floor(0.1); // 0
            double result42 = Math.Floor(0.9); // 0
            double result43 = Math.Floor(1.1); // 1
            double result44 = Math.Floor(1.9); // 1
            double result51 = Math.Floor(-0.1); // -1
            double result52 = Math.Floor(-0.9); // -1
            double result53 = Math.Floor(-1.1); // -2
            double result54 = Math.Floor(-1.9); // -2
            Console.WriteLine("Math.Floor(0.1)) = " + result41);
            Console.WriteLine("Math.Floor(0.9)) = " + result42);
            Console.WriteLine("Math.Floor(1.1)) = " + result43);
            Console.WriteLine("Math.Floor(1.9)) = " + result44);
            Console.WriteLine("Math.Floor(-0.1)) = " + result51);
            Console.WriteLine("Math.Floor(-0.9)) = " + result52);
            Console.WriteLine("Math.Floor(-1.1)) = " + result53);
            Console.WriteLine("Math.Floor(-1.9)) = " + result54);

            // 小数部の桁数を指定した切り捨て(Math.Floor) 
            Console.WriteLine("小数部の桁数を指定した切り捨て(Math.Floor) ");
            double result61 = Math.Floor(0.1234 * Math.Pow(10, 1)) / Math.Pow(10, 1); // 0.1
            double result62 = Math.Floor(0.1234 * Math.Pow(10, 2)) / Math.Pow(10, 2); // 0.12
            double result63 = Math.Floor(0.1234 * Math.Pow(10, 3)) / Math.Pow(10, 3); // 0.123
            double result71 = Math.Floor(-0.1234 * Math.Pow(10, 1)) / Math.Pow(10, 1); // -0.2
            double result72 = Math.Floor(-0.1234 * Math.Pow(10, 2)) / Math.Pow(10, 2); // -0.13
            double result73 = Math.Floor(-0.1234 * Math.Pow(10, 3)) / Math.Pow(10, 3); // -0.124
            Console.WriteLine("Math.Floor(0.1234 * Math.Pow(10, 1)) / Math.Pow(10, 1) = " + result51);
            Console.WriteLine("Math.Floor(0.1234 * Math.Pow(10, 2)) / Math.Pow(10, 2) = " + result52);
            Console.WriteLine("Math.Floor(0.1234 * Math.Pow(10, 3)) / Math.Pow(10, 3) = " + result53);
            Console.WriteLine("Math.Floor(-0.1234 * Math.Pow(10, 1)) / Math.Pow(10, 1) = " + result61);
            Console.WriteLine("Math.Floor(-0.1234 * Math.Pow(10, 2)) / Math.Pow(10, 2) = " + result62);
            Console.WriteLine("Math.Floor(-0.1234 * Math.Pow(10, 3)) / Math.Pow(10, 3) = " + result63);
        }

        /// <summary>
        /// 切り上げ
        /// </summary>
        static void Ceiling()
        {
            // 切り上げ
            Console.WriteLine("切り上げ");
            double result01 = Math.Ceiling(0.1); // 1
            double result02 = Math.Ceiling(0.9); // 1
            double result03 = Math.Ceiling(1.1); // 2
            double result04 = Math.Ceiling(1.9); // 2
            Console.WriteLine("Math.Ceiling(0.1)) = " + result01);
            Console.WriteLine("Math.Ceiling(0.9)) = " + result02);
            Console.WriteLine("Math.Ceiling(1.1)) = " + result03);
            Console.WriteLine("Math.Ceiling(1.9)) = " + result04);

            // マイナス値の切り上げ(0に寄せる)
            Console.WriteLine("マイナス値の切り上げ(0に寄せる)");
            double result11 = Math.Ceiling(-0.1); // 0
            double result12 = Math.Ceiling(-0.9); // 0
            double result13 = Math.Ceiling(-1.1); // -1
            double result14 = Math.Ceiling(-1.9); // -1
            Console.WriteLine("Math.Ceiling(-0.1)) = " + result11);
            Console.WriteLine("Math.Ceiling(-0.9)) = " + result12);
            Console.WriteLine("Math.Ceiling(-1.1)) = " + result13);
            Console.WriteLine("Math.Ceiling(-1.9)) = " + result14);

            // マイナス値の切り上げ(0から遠ざける)
            Console.WriteLine("マイナス値の切り上げ(0から遠ざける)");
            double result21 = Math.Floor(-0.1); // -1
            double result22 = Math.Floor(-0.9); // -1
            double result23 = Math.Floor(-1.1); // -2
            double result24 = Math.Floor(-1.9); // -2
            Console.WriteLine("Math.Floor(-0.1)) = " + result21);
            Console.WriteLine("Math.Floor(-0.9)) = " + result22);
            Console.WriteLine("Math.Floor(-1.1)) = " + result23);
            Console.WriteLine("Math.Floor(-1.9)) = " + result24);

            // 小数部の桁数を指定した切り上げ
            Console.WriteLine("小数部の桁数を指定した切り上げ");
            double result31 = Math.Ceiling(0.1234 * Math.Pow(10, 1)) / Math.Pow(10, 1); // 0.2
            double result32 = Math.Ceiling(0.1234 * Math.Pow(10, 2)) / Math.Pow(10, 2); // 0.13
            double result33 = Math.Ceiling(0.1234 * Math.Pow(10, 3)) / Math.Pow(10, 3); // 0.124
            double result41 = Math.Floor(-0.1234 * Math.Pow(10, 1)) / Math.Pow(10, 1); // -0.2
            double result42 = Math.Floor(-0.1234 * Math.Pow(10, 2)) / Math.Pow(10, 2); // -0.13
            double result43 = Math.Floor(-0.1234 * Math.Pow(10, 3)) / Math.Pow(10, 3); // -0.124
            Console.WriteLine("Math.Ceiling(0.1234 * Math.Pow(10, 1)) / Math.Pow(10, 1) = " + result31);
            Console.WriteLine("Math.Ceiling(0.1234 * Math.Pow(10, 2)) / Math.Pow(10, 2) = " + result32);
            Console.WriteLine("Math.Ceiling(0.1234 * Math.Pow(10, 3)) / Math.Pow(10, 3) = " + result33);
            Console.WriteLine("Math.Floor(-0.1234 * Math.Pow(10, 1)) / Math.Pow(10, 1) = " + result41);
            Console.WriteLine("Math.Floor(-0.1234 * Math.Pow(10, 2)) / Math.Pow(10, 2) = " + result42);
            Console.WriteLine("Math.Floor(-0.1234 * Math.Pow(10, 3)) / Math.Pow(10, 3) = " + result43);
        }

        /// <summary>
        /// 小数部の桁数を指定した切り捨て
        /// </summary>
        /// <param name="value">切り捨て対象の10進数</param>
        /// <param name="digits">戻り値の少数部の桁数</param>
        /// <returns>切り捨て結果</returns>
        static double Truncate(double value, int digits)
        {
            double powValue = Math.Pow(10, digits);
            return Math.Truncate(value * powValue) / powValue;
        }

        /// <summary>
        /// 小数部の桁数を指定した切り上げ
        /// </summary>
        /// <param name="value">切り上げ対象の10進数</param>
        /// <param name="digits">戻り値の少数部の桁数</param>
        /// <returns>切り上げ結果</returns>
        static double Ceiling(double value, int digits)
        {
            double powValue = Math.Pow(10, digits);
            if (value >= 0)
            {
                return Math.Ceiling(value * powValue) / powValue;
            }
            else
            {
                return Math.Floor(value * powValue) / powValue;
            }
        }
    }
}
